/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropRole
 *  fire.pb.battle.BattleConfig
 *  fire.pb.battle.BattleEndHandler
 *  fire.pb.battle.BattleField
 *  fire.pb.battle.Module
 *  fire.pb.battle.PNewBattle
 *  fire.pb.circletask.CircTask
 *  fire.pb.circletask.CircleTaskManager
 *  fire.pb.talk.MessageMgr
 *  fire.pb.talk.STransChatMessageNotify2Client
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  gnet.link.Onlines
 *  mkdb.Transaction
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 *  xbean.CircleTaskInfo
 *  xbean.CircleTaskMap
 *  xtable.Rolecircletask
 */
package fire.pb.circletask.catchit;

import fire.pb.PropRole;
import fire.pb.battle.BattleConfig;
import fire.pb.battle.BattleEndHandler;
import fire.pb.battle.BattleField;
import fire.pb.battle.Module;
import fire.pb.battle.PNewBattle;
import fire.pb.circletask.CircTask;
import fire.pb.circletask.CircleTaskManager;
import fire.pb.circletask.catchit.CatchItTaskEndHandler;
import fire.pb.talk.MessageMgr;
import fire.pb.talk.STransChatMessageNotify2Client;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import gnet.link.Onlines;
import java.util.ArrayList;
import java.util.List;
import mkdb.Transaction;
import mkio.Protocol;
import org.apache.log4j.Logger;
import xbean.CircleTaskInfo;
import xbean.CircleTaskMap;
import xtable.Rolecircletask;

public class EnterCatchItBattle {
    private final long roleid;
    private final long npckey;
    private final int npcid;
    private final int ctquestid;
    public static Logger logger = Logger.getLogger((String)"TASK");

    public EnterCatchItBattle(long roleid, long npckey, int npcid, int ctquestid) {
        this.roleid = roleid;
        this.npckey = npckey;
        this.npcid = npcid;
        this.ctquestid = ctquestid;
    }

    public void enterBattle() {
        PNewBattle battle;
        int battleCfgId;
        PropRole prole = new PropRole(this.roleid, true);
        CircleTaskMap questMap = Rolecircletask.select((Long)this.roleid);
        if (null == questMap) {
            return;
        }
        CircleTaskInfo questinfo = (CircleTaskInfo)questMap.getTaskmap().get(this.ctquestid);
        if (null == questinfo) {
            return;
        }
        CircTask ct = CircleTaskManager.getInstance().getCircTask(questinfo.getId());
        if (ct == null) {
            return;
        }
        if (ct.teamnum > 0) {
            Team team = TeamManager.selectTeamByRoleId((long)this.roleid);
            if (null == team || !team.isTeamLeader(this.roleid)) {
                return;
            }
            List members = team.getNormalMemberIds();
            if (members.size() < ct.teamnum) {
                STransChatMessageNotify2Client notify = MessageMgr.getMsgNotify((int)140277, (int)this.npcid, null);
                Onlines.getInstance().send(Long.valueOf(this.roleid), (Protocol)notify);
                return;
            }
            ArrayList<String> levelApplyNames = new ArrayList<String>(5);
            for (Long mem : team.getNormalMemberIds()) {
                PropRole memberRole = new PropRole(mem.longValue(), true);
                if (memberRole.getLevel() >= ct.levelmin) continue;
                levelApplyNames.add(memberRole.getName());
            }
            if (levelApplyNames.size() > 0) {
                StringBuffer strParam = new StringBuffer();
                int nIndex = 0;
                for (String name : levelApplyNames) {
                    if (nIndex != levelApplyNames.size() - 1) {
                        strParam.append(name).append(",");
                        continue;
                    }
                    strParam.append(name);
                }
                ArrayList<String> paras = new ArrayList<String>(2);
                paras.add(strParam.toString());
                paras.add(String.valueOf(ct.levelmin));
                for (Long mem : team.getNormalMemberIds()) {
                    STransChatMessageNotify2Client notify = MessageMgr.getMsgNotify((int)150523, (int)0, paras);
                    Onlines.getInstance().send(mem, (Protocol)notify);
                }
                return;
            }
        }
        if ((battleCfgId = questinfo.getDstitemid()) <= 0) {
            return;
        }
        BattleConfig battleConfig = (BattleConfig)Module.getInstance().getBattleConfigs().get(battleCfgId);
        if (battleConfig == null || battleConfig.monsterRands.size() == 0) {
            BattleField.logger.error((Object)("无法通过EnterCatchItBattle的战斗配置id获得参与战斗的怪物，BattleConfigId：" + battleCfgId + " roleid =" + this.roleid + " npckey =" + this.npckey + " npcid =" + this.npcid + " ctquestid =" + this.ctquestid));
            return;
        }
        CatchItTaskEndHandler handler = new CatchItTaskEndHandler(this.npckey, this.roleid, this.ctquestid, ct.teamnum, ct.teamshare);
        if (Transaction.current() != null) {
            battle = new PNewBattle(this.roleid, battleCfgId, 15, questinfo.getNpcname(), (BattleEndHandler)handler);
            battle.call();
        } else {
            battle = new PNewBattle(this.roleid, battleCfgId, 15, questinfo.getNpcname(), (BattleEndHandler)handler);
            battle.submit();
        }
        logger.debug((Object)("玩家   " + prole.getName() + "进入大萌任务"));
    }
}

